package at.ac.uibk.gitsearch.es.model;

import at.ac.uibk.gitsearch.service.dto.MetadataUserDTO;
import com.fasterxml.jackson.annotation.*;

import java.io.IOException;
import java.util.List;

public class ExerciseInfo {

    private String metadataVersion;

    private ExerciseType type;

    private String title;

    private String license;

    private List<String> keyword;

    private List<String> format;

    private String structure;

    private List<String> programmingLanguage;

    private List<String> language;

    private ExerciseDifficulty difficulty;

    @JsonInclude(JsonInclude.Include.NON_EMPTY)
    private List<MetadataUserDTO> creator;

    @JsonInclude(JsonInclude.Include.NON_EMPTY)
    private List<MetadataUserDTO> contributor;

    private List<String> source;

    public ExerciseInfo() {
    }

    public String getMetadataVersion() {
        return metadataVersion;
    }

    public void setMetadataVersion(String metadataVersion) {
        this.metadataVersion = metadataVersion;
    }

    public ExerciseType getType() {
        return type;
    }

    public void setType(ExerciseType type) {
        this.type = type;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getLicense() {
        return license;
    }

    public void setLicense(String license) {
        this.license = license;
    }

    public List<String> getKeyword() {
        return keyword;
    }

    public void setKeyword(List<String> keyword) {
        this.keyword = keyword;
    }

    public List<String> getFormat() {
        return format;
    }

    public void setFormat(List<String> format) {
        this.format = format;
    }

    public String getStructure() {
        return structure;
    }

    public void setStructure(String structure) {
        this.structure = structure;
    }

    public List<String> getProgrammingLanguage() {
        return programmingLanguage;
    }

    public void setProgrammingLanguage(List<String> programmingLanguage) {
        this.programmingLanguage = programmingLanguage;
    }

    public List<String> getLanguage() {
        return language;
    }

    public void setLanguage(List<String> language) {
        this.language = language;
    }

    public ExerciseDifficulty getDifficulty() {
        return difficulty;
    }

    public void setDifficulty(ExerciseDifficulty difficulty) {
        this.difficulty = difficulty;
    }

    public List<String> getSource() {
        return source;
    }

    public void setSource(List<String> source) {
        this.source = source;
    }

    @JsonProperty("creator")
    public List<MetadataUserDTO> getCreator() {
        return creator;
    }

    public void setCreator(List<MetadataUserDTO> creator) {
        this.creator = creator;
    }

    @JsonProperty("contributor")
    public List<MetadataUserDTO> getContributor() {
        return contributor;
    }

    public void setContributor(List<MetadataUserDTO> contributor) {
        this.contributor = contributor;
    }

    @Override
    public String toString() {
        return "ExerciseInfo{" +
            "metadataVersion='" + metadataVersion + '\'' +
            ", type=" + type +
            ", title='" + title + '\'' +
            ", license='" + license + '\'' +
            ", keyword=" + keyword +
            ", format=" + format +
            ", structure='" + structure + '\'' +
            ", programmingLanguage=" + programmingLanguage +
            ", language=" + language +
            ", difficulty=" + difficulty +
            ", creator=" + creator +
            ", contributor=" + contributor +
            ", source=" + source +
            '}';
    }

    @JsonFormat
    public enum ExerciseType {PROGRAMMING_EXERCISE("programming exercise"), EXERCISE("exercise"), COLLECTION("collection"), OTHER("other");
        ExerciseType(String s) {
        }

        @Override
        public String toString() {
            return name().toLowerCase().replace("_", " ");
        }
    }

    public enum ExerciseDifficulty {
        SIMPLE,
        MEDIUM,
        ADVANCED,
        @JsonEnumDefaultValue NONE;

        @Override
        public String toString() {
            return name().toLowerCase();
        }
    }


}
