import { Exercise, IExerciseType } from 'app/shared/model/exercise.model';
import { Person } from 'app/shared/model/person.model';
import { SearchResultDTO } from 'app/shared/model/search/search-result-dto.model';

export enum ExerciseMode {
  INDIVIDUAL = 'individual',
  TEAM = 'team',
}

export class ArtemisExerciseInfo implements Exercise {
  constructor(
    public contributor: Person[],
    public creator: Person[],
    public deprecated: boolean,
    public description: string,
    public downloads: number,
    public educationLevel: string,
    public format: Array<string>,
    public gitlabURL: string,
    public imageURL: string,
    public keyword: Array<string>,
    public languages: string[],
    public lastUpdate: Date,
    public license: string,
    public metadataVersion: string,
    public originalResult: SearchResultDTO,
    public programmingLanguages: string[],
    public source: string,
    public publisher: Person[],
    public rating: number,
    public requires: string[],
    public status: string,
    public structure: string,
    public timeRequired: string,
    public title: string,
    public type: IExerciseType,
    public version: string,
    public views: number,
    public difficulty?: string,
    // Artemis only metadata
    public maxPoints?: number,
    public bonusPoints?: number,
    public mode?: ExerciseMode,
    public staticCodeAnalysis?: boolean,
    public allowOfflineIDE?: boolean,
    public allowOnlineEditor?: boolean,
    public showTestNamesToStudents?: boolean,
    public sequentialTestRuns?: boolean
  ) {}
}
